﻿Imports System.IO
Imports System.Xml.Serialization
Public Class BaseXML
    Public Sub SaveXml(ByVal FileName As String)
        Dim tempFileName As String
        tempFileName = FileName & ".tmp"
        Dim tempFileInfo As New FileInfo(tempFileName)
        If tempFileInfo.Exists Then
            tempFileInfo.Delete()
        End If
        Dim stream As New FileStream(tempFileName, FileMode.Create)
        SaveXml(stream)
        stream.Close()
        tempFileInfo.CopyTo(FileName, True)
        tempFileInfo.Delete()
    End Sub

    Private Sub SaveXml(ByVal stream As FileStream)

        Dim serializer As New XmlSerializer(Me.GetType)
        serializer.Serialize(stream, Me)
    End Sub
    Public Shared Function Load(ByVal filename As String, ByVal newtype As Type) As Object
        Dim fileInfo As New FileInfo(filename)
        If fileInfo.Exists = False Then
            Return System.Activator.CreateInstance(newtype)
        End If

        Dim stream As New FileStream(filename, FileMode.Open)
        Dim newObject As Object = Load(stream, newtype)
        stream.Close()
        Return newObject
    End Function

    Private Shared Function Load(ByVal stream As Stream, ByVal newtype As Type) As Object
        Dim serializer As New XmlSerializer(newtype)
        Dim newobject As Object = serializer.Deserialize(stream)
        Return newobject
    End Function

End Class
