﻿Public Class DataQuery
    Private ds As DataSet '存储xml节点
    Private dt As DataTable
    Private MydbReader As OleDb.OleDbDataReader
    Private Flag As Boolean = True '打开程序时cbo selectchanges 事件标记,禁止第一打开程序是运行selectchanges事件
    Private ConnName, HostName, PortNo, DataBase, UserID, PassWord, mySQL As String
    Private strstreamReader As System.IO.StreamReader
    Private strstreamWrite As System.IO.StreamWriter
    Private objData As DAClass

    Private Sub DataQuery_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If objData IsNot Nothing Then objData.Dispose()
        If ds IsNot Nothing Then ds.Dispose()
        If dt IsNot Nothing Then dt.Dispose()
        If MydbReader IsNot Nothing Then MydbReader.Close()


        'objData.Dispose()
        'ds.Dispose()
        'dt.Dispose()
        'dbReader.Close()
    End Sub

    Private Sub DataQuery_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Dim fileinfo As New System.IO.FileInfo(".\record.xml")
        'If fileinfo.Exists Then
        '    ds = New DataSet
        '    ds.ReadXml(".\record.xml")
        'End If
        Me.Text = My.Application.Info.Title.ToString & " " & My.Application.Info.Version.ToString
        Try
            If My.Computer.FileSystem.FileExists(".\record.xml") Then
                ds = New DataSet
                ds.ReadXml(".\record.xml")

                If ds.Tables.Count = 0 Then

                    MsgBox("还没有连接点，请添加")
                  
                    Exit Sub
                End If
                Dim row As DataRow = ds.Tables("record").NewRow   '在0列插入一个SelectNode节点
                row.Item("ConnName") = "Select Node"
                ds.Tables("record").Rows.InsertAt(row, 0)
                cboName.DataSource = ds.Tables("record")
                cboName.DisplayMember = "ConnName"
                Flag = False
            Else
                MsgBox("找不到连接，请添加")
            End If
            ToolStripDate.Text = Today.Date
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

   
  

    Private Sub btnSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectAll.Click
        If btnSelectAll.Text = "全选" Then
            For i As Integer = 0 To chkOutputFiled.Items.Count - 1
                chkOutputFiled.SetItemChecked(i, True)
            Next
            btnSelectAll.Text = "取消"
        Else
            For i As Integer = 0 To chkOutputFiled.Items.Count - 1
                chkOutputFiled.SetItemChecked(i, False)
            Next
            btnSelectAll.Text = "全选"
        End If
    End Sub

    Private Sub 添加新连接ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 添加新连接ToolStripMenuItem.Click
        If cboName.SelectedIndex <> -1 Then
            Dim addcon As New AddCon(cboName.SelectedItem("ConnName"))
            addcon.btnSave.Visible = False
            addcon.btnDelete.Visible = False
            addcon.ShowDialog()
            addcon.Dispose()
            addcon = Nothing
        Else
            Dim addcon As New AddCon()
            addcon.btnSave.Visible = False
            addcon.btnDelete.Visible = False
            addcon.ShowDialog()
            addcon.Dispose()
            addcon = Nothing
        End If


    End Sub

    Private Sub 连接设置ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 连接设置ToolStripMenuItem1.Click
        If cboName.SelectedIndex <> -1 Then
            Dim addcon As New AddCon(cboName.SelectedItem("ConnName"))
            addcon.btnNew.Visible = False
            addcon.ShowDialog()
            addcon.Dispose()
            addcon = Nothing
        Else
            MsgBox("无连接,请添加")
        End If
    End Sub

    Private Sub cboName_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboName.SelectedIndexChanged
        If cboName.SelectedIndex = 0 Then '程序首次加载判断和选择判断，如果首次或者是SelectNode运行下面，然后退出
            ToolStripStatus.Text = "Ready"
            cboDB.Items.Clear()
            cboTable.Items.Clear()
            chkOutputFiled.Items.Clear()
            chkQueryFIiled.Items.Clear()
            DataGridView1.DataSource = Nothing

            lblDataViewFileCount.Text = Nothing
            Exit Sub
        End If

        Dim items As DataRow = ds.Tables("record").Rows(cboName.SelectedIndex) '得到cboname选择的row
        '  ds.Tables(0).PrimaryKey = New DataColumn() {ds.Tables(0).Columns("ConnName")}
        '   Dim items As DataRow=ds.Tables ("record").Rows .Find (cboName .SelectedItem ("ConnName")) '另外一种得到当前row数据的方法
        ConnName = items.Item("ConnName")
        HostName = items.Item("HostName")
        DataBase = items.Item("DataBase")
        PortNo = items.Item("PortNo")
        UserID = items.Item("UserID")
        PassWord = items.Item("PassWord")
        items = Nothing
       
        DataGridView1.DataSource = Nothing
        lblDataViewFileCount.Text = Nothing
        chkOutputFiled.Items.Clear()
        chkQueryFIiled.Items.Clear()
        btnSelectAll.Text = "全选"
        cboDB.Items.Clear()
        cboTable.Items.Clear()
        Try
            objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
            dt = New DataTable
            dt = objData.Gettabschema
            cboDB.Items.Add("Select DB")
            For i As Integer = 0 To dt.Rows.Count - 1
                cboDB.Items.Add(dt.Rows(i).Item("tabschema"))
            Next
            cboDB.SelectedIndex = 0
            dt.Dispose()
            dt = Nothing
            objData.Dispose()
            objData = Nothing
            ToolStripStatus.Text = "当前主机-" & HostName
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub cboDB_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboDB.SelectedIndexChanged
        cboTable.Items.Clear()
        chkOutputFiled.Items.Clear()
        chkQueryFIiled.Items.Clear()
        btnSelectAll.Text = "全选"
        DataGridView1.DataSource = Nothing
        lblDataViewFileCount.Text = Nothing
        If cboDB.SelectedIndex = 0 Then Exit Sub

        Try
            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                dt = New DataTable
                dt = objData.GetTableName(cboDB.SelectedItem)
                cboTable.Items.Add("Select Table")
                For i As Integer = 0 To dt.Rows.Count - 1
                    cboTable.Items.Add(dt.Rows(i).Item("tabname"))
                Next
                cboTable.SelectedIndex = 0
                dt.Dispose()
                dt = Nothing
            End Using
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub cboTable_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboTable.SelectedIndexChanged
        chkOutputFiled.Items.Clear()
        chkQueryFIiled.Items.Clear()
        btnSelectAll.Text = "全选"
        DataGridView1.DataSource = Nothing
        lblDataViewFileCount.Text = Nothing
        If cboTable.SelectedIndex = 0 Then Exit Sub
        Try
            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                dt = New DataTable
                dt = objData.GetFileds(cboTable.SelectedItem, cboDB.SelectedItem)
                For i As Integer = 0 To dt.Rows.Count - 1
                    chkQueryFIiled.Items.Add(dt.Rows(i).Item("COLNAME") & " (" & dt.Rows(i).Item("typename") & ")")
                    chkOutputFiled.Items.Add(dt.Rows(i).Item("COLNAME"))
                Next
                dt.Dispose()
                dt = Nothing
            End Using
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

  

   

   
   
    Private Sub DataQuery_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        If Module1.Activated Then                        '从addcon窗体返回时重新加载xml文件
            Module1.Activated = False
            DataQuery_Load(sender, e)

        End If

    End Sub

#Region "界面右边输入语句查询代码"

    Private Sub btnReturn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReturn.Click
        Try
            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)

                mySQL = "Select " & Optfileds(chkOutputFiled) & " From " & Trim(cboDB.SelectedItem) & "." & cboTable.SelectedItem & " FETCH FIRST 100 ROWS ONLY"

                'objData.OpenConnection()
                'dbReader = objData.SqlQuery(objData.SQL)
                'DataGridView1.DataSource = dbReader
                'dbReader.Read()
                'MsgBox(dbReader.Item(1).ToString)
                '' dbReader.Close()

                'objData.CloseConnection()
                ''  dbReader = Nothing
                dt = New DataTable
                dt = objData.SqlQueryDBtable(mySQL)

                DataGridView1.DataSource = dt
                dt.Dispose()
                dt = Nothing
                lblDataViewFileCount.Text = "受影响记录 " & DataGridView1.Rows.Count
                txtInputSql.Text = objData.SQL
            End Using
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnSqlQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSqlQuery.Click
        Try
            Me.Cursor = Cursors.WaitCursor
            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                mySQL = txtInputSql.Text
                dt = New DataTable
                dt = objData.SqlQueryDBtable(mySQL)
                DataGridView1.DataSource = dt
                dt.Dispose()
                dt = Nothing
                lblDataViewFileCount.Text = "受影响记录 " & DataGridView1.Rows.Count
                MsgBox("查询结束")
            End Using
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            Me.Cursor = Cursors.Default
        End Try
    End Sub

    Private Sub btnextFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnextFile.Click
        Dim savetxt As New SaveFileDialog
        With savetxt
            .DefaultExt = "txt"
            .FileName = "Result"
            .Filter = "Txt File|*.txt|CSV File|*.csv"
        End With
        If savetxt.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim sb As New System.Text.StringBuilder
            For i As Integer = 0 To DataGridView1.ColumnCount - 1
                sb.Append(DataGridView1.Columns(i).HeaderText.ToString)
                sb.Append(",")
            Next
            sb.AppendLine()
            For i As Integer = 0 To DataGridView1.Rows.Count - 1
                For j As Integer = 0 To DataGridView1.Columns.Count - 1
                    sb.Append(DataGridView1.Rows(i).Cells(j).Value.ToString)
                    sb.Append(",")
                Next
                sb.AppendLine()
            Next
            My.Computer.FileSystem.WriteAllText(savetxt.FileName, sb.ToString, False, System.Text.Encoding.GetEncoding(0))
            MsgBox("保存成功")
            sb = Nothing
        End If
        savetxt.Dispose()
        savetxt = Nothing
    End Sub

#End Region
    Private Function Optfileds(ByVal chk As CheckedListBox) As String  '得到输入字段
        Optfileds = Nothing
        If chk.CheckedItems.Count <> 0 Then
            For i As Integer = 0 To chk.CheckedItems.Count - 1
                Optfileds &= chk.CheckedItems(i).ToString & ","
            Next
            Optfileds = Optfileds.Substring(0, Optfileds.Length - 1)
        Else
            Optfileds = "*"
        End If
    End Function

    Private Sub btnsubmit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnsubmit.Click
        Dim saveDialog As New SaveFileDialog
        With saveDialog
            .DefaultExt = "txt"
            .FileName = "Result"
            .Filter = "Txt File|*.txt|CSV File|*.csv"
        End With
        If RdoinputValue.Checked Then
            If chkQueryFIiled.CheckedItems.Count = 0 Then MsgBox("请选择查询关键字") : Exit Sub
            If txtInputValue.Text = Nothing Then MsgBox("请输入查询值") : Exit Sub
            If chkQueryFIiled.CheckedItems.Count <> txtInputValue.Lines(0).Split(",").Length Then MsgBox("查询关键字段数和查询值不符") : Exit Sub
            If chkOutputFiled.CheckedItems.Count = 0 Then MsgBox("请选择输出字段") : Exit Sub

            ' Try
            If saveDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
                lblStatus.Visible = True
                Application.DoEvents()
                If txtother.Text.Trim = Nothing Then
                    GetResults(saveDialog.FileName)
                Else
                    getOtherResults(saveDialog.FileName)
                End If

                lblStatus.Visible = False
                MsgBox("保存成功")

            End If

            ' Catch ex As Exception
            '   MsgBox(ex.Message)
            '  End Try
        Else
            If txtSelectValueFile.Text = Nothing Then
                MsgBox("请选择文件")
            Else
                Dim strtmp As String
                Using strstreamReader = New System.IO.StreamReader(txtSelectValueFile.Text.Trim)
                    strtmp = strstreamReader.ReadLine
                End Using
                If strtmp IsNot Nothing Then
                    If chkQueryFIiled.CheckedItems.Count = 0 Then MsgBox("请选择查询关键字") : Exit Sub
                    If chkOutputFiled.CheckedItems.Count = 0 Then MsgBox("请选择输出字段") : Exit Sub
                    If chkQueryFIiled.CheckedItems.Count <> strtmp.Split(",").Length Then MsgBox("查询关键字段数和查询值不符") : Exit Sub
                    If saveDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
                        lblStatus.Visible = True
                        Application.DoEvents()
                        GetResults(saveDialog.FileName)
                        lblStatus.Visible = False
                        MsgBox("保存成功")

                    End If
                Else
                    MsgBox("文件为空")
                End If

            End If

        End If
        saveDialog.Dispose()


    End Sub
    Private Sub GetResults(ByVal path As String)
        If RdoinputValue.Checked Then
            mySQL = "Select " & Optfileds(chkOutputFiled) & " From " & cboDB.SelectedItem.ToString.Trim & "." & Trim(cboTable.SelectedItem) _
                & " where "
            Dim txtchk(), txtline(), txtname(), strtmp As String 'txtchk用于保存单行的查询关键字的值，txtline用于保存查询输入值每行的值，
            'txtname用于保存得出的查询关键字，
            strtmp = Nothing
            For i As Integer = 0 To chkQueryFIiled.CheckedItems.Count - 1 '计算查询关键字
                txtchk = chkQueryFIiled.CheckedItems(i).ToString.Split(New Char() {"(", ")"})
                mySQL &= txtchk(0).ToString.Trim & "=" & "? " & "and "
                strtmp &= txtchk(0).ToString & ","
            Next
            strtmp = strtmp.Substring(0, strtmp.Length - 1) '去掉最后一个“，” 
            txtname = strtmp.Split(",") '转换查询关键字为数组
            mySQL = mySQL.Substring(0, mySQL.Length - 4) '去掉最后面的“ and”

            '  Try
            Me.Cursor = Cursors.WaitCursor
            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                objData.SQL = mySQL
                objData.InitializeCommand()
                objData.OpenConnection()
                For i As Integer = 0 To txtname.Length - 1 '添加parameter
                    objData.AddParameter(txtname(i), Nothing)
                Next
                Using strstreamWrite = New System.IO.StreamWriter(path)

                    strstreamWrite.WriteLine(Optfileds(chkOutputFiled)) '写入字段头
                    For i As Integer = 0 To txtInputValue.Lines.Count - 1 '循环txtbox的所有行
                        If txtInputValue.Lines(i).ToString.Trim <> Nothing Then


                            txtline = txtInputValue.Lines(i).Split(",")
                            For j As Integer = 0 To txtInputValue.Lines(0).ToString.Split(",").Length - 1 '循环所有列
                                objData.Command.Parameters(txtname(j)).Value = txtline(j).ToString.Trim
                            Next
                            MydbReader = objData.Command.ExecuteReader
                            While MydbReader.HasRows AndAlso MydbReader.Read
                                strtmp = Nothing
                                For x As Integer = 0 To MydbReader.FieldCount - 1
                                    strtmp &= MydbReader.Item(x).ToString & ","
                                Next
                                strtmp = strtmp.Substring(0, strtmp.Length - 1)
                                strstreamWrite.WriteLine(strtmp)
                            End While
                            MydbReader.Close()
                        End If
                    Next
                    MydbReader = Nothing
                    objData.CloseConnection()
                    strstreamWrite.Close()
                End Using
            End Using
            'Catch ex As Exception
            ' Throw New Exception(ex.Message)
            ' Finally
            Me.Cursor = Cursors.Default
            'End Try
        End If
        If RdoSelectValueFile.Checked Then
            mySQL = "Select " & Optfileds(chkOutputFiled) & " From " & cboDB.SelectedItem.ToString.Trim & "." & Trim(cboTable.SelectedItem) _
              & " where "
            Dim txtchk(), txtline(), txtname(), strtmp As String 'txtchk用于保存单行的查询关键字的值，txtline用于保存查询输入值每行的值，
            'txtname用于保存得出的查询关键字，
            strtmp = Nothing
            For i As Integer = 0 To chkQueryFIiled.CheckedItems.Count - 1 '计算查询关键字
                txtchk = chkQueryFIiled.CheckedItems(i).ToString.Split(New Char() {"(", ")"})
                mySQL &= txtchk(0).ToString.Trim & "=" & "? " & "and "
                strtmp &= txtchk(0).ToString & ","
            Next
            strtmp = strtmp.Substring(0, strtmp.Length - 1) '去掉最后一个“，” 
            txtname = strtmp.Split(",") '转换查询关键字为数组
            mySQL = mySQL.Substring(0, mySQL.Length - 4) '去掉最后面的“ and”
            Try
                Me.Cursor = Cursors.WaitCursor
                Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                    objData.SQL = mySQL
                    objData.InitializeCommand()
                    objData.OpenConnection()
                    For i As Integer = 0 To txtname.Length - 1 '添加parameter
                        objData.AddParameter(txtname(i), Nothing)
                    Next
                    Using strstreamWrite = New System.IO.StreamWriter(path)
                        strstreamWrite.WriteLine(Optfileds(chkOutputFiled)) '写入字段头
                        Using strstreamReader = New System.IO.StreamReader(txtSelectValueFile.Text.Trim)
                            strtmp = strstreamReader.ReadLine.Trim
                            While strtmp IsNot Nothing
                                txtline = strtmp.Split(",")
                                For j As Integer = 0 To strtmp.Split(",").Length - 1 '循环所有列
                                    objData.Command.Parameters(txtname(j)).Value = txtline(j).ToString.Trim
                                Next
                                MydbReader = objData.Command.ExecuteReader
                                While MydbReader.HasRows AndAlso MydbReader.Read
                                    strtmp = Nothing
                                    For x As Integer = 0 To MydbReader.FieldCount - 1
                                        strtmp &= MydbReader.Item(x).ToString & ","
                                    Next
                                    strtmp = strtmp.Substring(0, strtmp.Length - 1)

                                    strstreamWrite.WriteLine(strtmp)
                                    strtmp = Nothing
                                End While
                                MydbReader.Close()
                                MydbReader = Nothing
                                strtmp = strstreamReader.ReadLine
                            End While

                        End Using

                    End Using

                End Using
            Catch ex As Exception
                Throw New Exception(ex.Message)
            Finally
                Me.Cursor = Cursors.Default
            End Try
        End If
    End Sub

    Private Sub getOtherResults(ByVal path As String)

        Try
            Me.Cursor = Cursors.WaitCursor
            Dim txtchk(), txtline(), strtmp As String 'txtchk用于保存单行的查询关键字的值，txtline用于保存查询输入值每行的值，
            'txtname用于保存得出的查询关键字，

            Using objData = New DAClass(UserID, PassWord, PortNo, DataBase, HostName)
                objData.OpenConnection()
                Using strstreamWrite = New System.IO.StreamWriter(path)

                    strstreamWrite.WriteLine(Optfileds(chkOutputFiled))

                    For i As Integer = 0 To txtInputValue.Lines.Count - 1
                        If txtInputValue.Lines(i).ToString.Trim <> Nothing Then


                            txtline = txtInputValue.Lines(i).Split(",")
                            mySQL = "Select " & Optfileds(chkOutputFiled) & " From " & cboDB.SelectedItem.ToString.Trim & "." & Trim(cboTable.SelectedItem) _
                         & " where "
                            For j As Integer = 0 To chkQueryFIiled.CheckedItems.Count - 1 '计算查询关键字
                                txtchk = chkQueryFIiled.CheckedItems(j).ToString.Split(New Char() {"(", ")"})
                                mySQL &= txtchk(0).ToString.Trim & "=" & IIf(txtchk(1).Trim = "INT", txtline(j).Trim, "'" & txtline(j).Trim & "'") & " and "

                            Next
                            mySQL &= txtother.Text
                            objData.SQL = mySQL
                            objData.InitializeCommand()



                            MydbReader = objData.Command.ExecuteReader()
                            While MydbReader.HasRows AndAlso MydbReader.Read
                                strtmp = Nothing
                                For x As Integer = 0 To MydbReader.FieldCount - 1
                                    strtmp &= MydbReader.Item(x).ToString & ","
                                Next
                                strtmp = strtmp.Substring(0, strtmp.Length - 1)

                                strstreamWrite.WriteLine(strtmp)
                            End While
                            MydbReader.Close()
                            MydbReader = Nothing
                            objData.Command = Nothing
                        End If
                    Next
                End Using
            End Using
        Catch ex As Exception
            Throw New Exception(ex.Message)
        Finally
            Me.Cursor = Cursors.Default
        End Try
      
    End Sub
    Private Sub chkOutputFiled_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkOutputFiled.SelectedIndexChanged
        If txtInputSql.Text.Trim = Nothing Then
            txtInputSql.Text = "Select " & Optfileds(chkOutputFiled) & " From " & cboDB.SelectedItem.ToString.Trim & "." & cboTable.SelectedItem.ToString.Trim & " Where "
        Else
            Dim i As Integer = txtInputSql.Text.IndexOf("From") '得出’From‘在字符的第几位
            Dim strtmp As String = txtInputSql.Text.Substring(i) '截取从From以后的字符
            txtInputSql.Text = "Select " & Optfileds(chkOutputFiled) & " " & strtmp
        End If
    End Sub

    Private Sub btnSelectValueFIle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectValueFIle.Click
        Dim openFile As New OpenFileDialog
        With openFile
            .Filter = "Txt File|*.txt"
        End With
        If openFile.ShowDialog = Windows.Forms.DialogResult.OK Then
            txtSelectValueFile.Text = openFile.FileName
        End If
        openFile.Dispose()
    End Sub

    Private Sub RdoSelectValueFile_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RdoSelectValueFile.CheckedChanged
        If RdoSelectValueFile.Checked = True Then
            btnSelectValueFIle.Enabled = True
            txtother.Enabled = False
        End If
    End Sub

    Private Sub RdoinputValue_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RdoinputValue.CheckedChanged
        If RdoinputValue.Checked = True Then
            btnSelectValueFIle.Enabled = False
            txtother.Enabled = True
        End If
    End Sub

   
   
End Class