﻿Imports System.Xml
Imports System.Xml.Linq
Public Class xmlOpt
    Private xel, rootNode As XElement
    Private xdoc As XDocument
    Private path As String
    Public Sub New()
        path = ".\record.xml"
    End Sub
    Public Sub xmlWrite(ByVal ConnName As String, ByVal HostName As String, ByVal DataBase As String, ByVal PortNo As String, ByVal UserID As String, ByVal PassWord As String)
        Dim myxmlsettings As New Xml.XmlWriterSettings
        myxmlsettings.Indent = True
        myxmlsettings.NewLineOnAttributes = True
        Using filemorderswriter As Xml.XmlWriter = Xml.XmlWriter.Create(".\record.xml", myxmlsettings)
            filemorderswriter.WriteStartElement("Table1")
            filemorderswriter.WriteStartElement("Record")
            filemorderswriter.WriteElementString("ConnName", ConnName)
            filemorderswriter.WriteElementString("HostName", HostName)
            filemorderswriter.WriteElementString("DataBase", DataBase)
            filemorderswriter.WriteElementString("PortNo", PortNo)
            filemorderswriter.WriteElementString("UserID", UserID)
            filemorderswriter.WriteElementString("PassWord", PassWord)
            filemorderswriter.WriteEndElement()
        End Using
    End Sub
    Public Sub CreateXml(ByVal ConnName As String, ByVal HostName As String, ByVal DataBase As String,
                         ByVal PortNo As String, ByVal UserID As String, ByVal PassWord As String)
        Try
            'xDoc = New XDocument (New XElement ("Table1",
            xel = New XElement("Table1",
                                     New XElement("Record", New XAttribute("ID", Guid.NewGuid.ToString.ToUpper),
                                        New XElement("ConnName", ConnName),
                                        New XElement("HostName", HostName),
                                        New XElement("DataBase", DataBase),
                                        New XElement("UserID", UserID),
                                        New XElement("PortNo", PortNo),
                                        New XElement("PassWord", PassWord)
                                     )
                                 )
            '  )
            xel.Save(path)
            xel = Nothing
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try


    End Sub
    Public Sub AppendNode(ByVal ConnName As String, ByVal HostName As String, ByVal DataBase As String,
                         ByVal PortNo As String, ByVal UserID As String, ByVal PassWord As String)
        Try
            rootNode = XElement.Load(path)
            Dim newNode As XElement = New XElement("Record", New XAttribute("ID", Guid.NewGuid.ToString.ToUpper),
                                                   New XElement("ConnName", ConnName),
                                        New XElement("HostName", HostName),
                                        New XElement("DataBase", DataBase),
                                        New XElement("UserID", UserID),
                                        New XElement("PortNo", PortNo),
                                        New XElement("PassWord", PassWord)
                                        )
            rootNode.Add(newNode)
            rootNode.Save(path)
            rootNode = Nothing
            newNode = Nothing
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub
    Public Sub ModifyNode(ByVal ConnName As String, ByVal HostName As String, ByVal DataBase As String,
                         ByVal PortNo As String, ByVal UserID As String, ByVal PassWord As String, ByVal id As String)
        Try
            rootNode = XElement.Load(path)
            Dim tragetNode As IEnumerable(Of XElement)
            tragetNode = From traget In rootNode.Descendants("Record") Where traget.Attribute("ID").Value = id Select traget

            For Each node As XElement In tragetNode
                node.Element("ConnName").SetValue(ConnName)
                node.Element("DataBase").SetValue(DataBase)
                node.Element("HostName").SetValue(HostName)
                node.Element("UserID").SetValue(HostName)
                node.Element("PortNo").SetValue(PortNo)
                node.Element("PassWord").SetValue(PassWord)
            Next
            rootNode.Save(path)
            rootNode = Nothing
            tragetNode = Nothing
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub
    Public Sub DeleteNode(ByVal id As String)
        Try
            rootNode = XElement.Load(path)
            Dim tragetNode As IEnumerable(Of XElement)
            tragetNode = From traget In rootNode.Descendants("Record") Where traget.Attribute("ID").Value = id Select traget

            tragetNode.Remove()
            rootNode.Save(path)
            rootNode = Nothing
            tragetNode = Nothing
        Catch ex As Exception
            Throw New Exception(ex.Message)
        End Try
    End Sub
End Class
